#include <linux/kernel.h>

#define CONFIG_SHA1_MAC 0

#define CIP_CRIT_PRINT(fmt, ...)		printk(KERN_CRIT "[CIP_KERNEL] " fmt,##__VA_ARGS__)
#define CIP_WARN_PRINT(fmt, ...)		printk(KERN_WARNING "[CIP_KERNEL] " fmt,##__VA_ARGS__)
#define CIP_DEBUG_PRINT(fmt, ...)		printk(KERN_DEBUG "[CIP_KERNEL] " fmt,##__VA_ARGS__)
#if CONFIG_SHA1_MAC
#define CI_CMAC_SIZE		(16)
#else
#define CI_CMAC_SIZE		(20)
#endif

#define CI_CMAC_RSA_SIZE	(128)
#define RSA_1024_SIGN_SIZE  (128)
#define SLEEP_WAITING       (10)

#define ROOTFS_PARTITION	("/dev/bml0/6")

#define SIGNAL_FLAG_TEST    "/dtv/.data_test"

typedef struct 
{
	unsigned char au8PreCmacResult[CI_CMAC_RSA_SIZE];	// MAC
	unsigned int msgLen;	// the length of a message to be authenticated
} MacInfo_t;

typedef struct 
{
    	MacInfo_t macAuthULD;
} macAuthULd_t;

int getAuthUld(macAuthULd_t *authuld);
int read_from_file_or_ff (int fd, unsigned char *buf, int size);
int verify_mstar_rsa_signature(unsigned char *pText, unsigned long pTextLen, unsigned char *signature, unsigned long signLen);


